#! /bin/env python
#


import numpy
import popen2

# todo:   popen2 is deprecated, one should use subprocess

def linreg(x,y,method=1):
    """interface to six linear regressions by Isobe et al. 1990
    using NEMO's linreg program.
    Input: x[], y[], method
    1=OLS(Y/X)  2=OLS(X/Y)  3=bisector  4=orthogonal
    5=reduced major axis  6=mean OLS
    Returns: (slope,intercept,slope_error,intercept_error)
    """
    toFloat=lambda x:[float(y) for y in x]
    x=toFloat(x)
    y=toFloat(y)
    n=len(x)
    out1,in1 = popen2.popen2('linreg - mode=%d debug=-1 maxline=%d' % (method,n))
    for i in range(0,len(x)):
        in1.write("%g %g\n" % (x[i],y[i]))
    in1.close()
    result = out1.read()
    out1.close()
    w = result.split()
    return (float(w[3]),float(w[1]),float(w[4]),float(w[2]))

if __name__ == '__main__':
    x=range(0,4)
    y=range(0,4)
    for i in range(0,4):
        y[i] = 2*x[i] + 1.0
    print linreg(x,y)
    print "Answer should be: 2 1 0 0"

